<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigCalculofolha extends Base\MigCalculofolha
{

    const DEFAULT_NROCORRECALC = '1';
    const DEFAULT_NRTPMODALIDCALC = '1';

    /**
     * @param $nrtipomoviment
     * @throws \Exception
     * @return \Folha\Entities\MigCalculofolha
     */
    public function setNrtipomoviment ($nrtipomoviment) {
        $nrorg = ProjetoImportacao::getNrorgPadrao();
        $tipomoviment = \Folha\Entities\Fpatipomoviment::getObjectByWhere('NRTIPOMOVIMENT = ? AND NRORG = ?', array($nrtipomoviment, $nrorg));

        if (is_object($tipomoviment)) {
            $this->nrtipomoviment = $nrtipomoviment;
        } else {
            throw new \Exception("O código do Tipo de Movimento '$nrtipomoviment' não foi encontrado.");
        }
    }

    /**
     * @param $nrocorrecal
     * @return \Folha\Entities\MigCalculofolha
     */
    public function setNrocorrecal ($nrocorrecal) {
        if (empty($nrocorrecal)) {
            $nrocorrecal = self::DEFAULT_NROCORRECALC;
        }
        $this->nrocorrecal = $nrocorrecal;
    }

    public function setNrcalculofolha($nrcalculofolha)
    {
//        $nrorg = ProjetoImportacao::getNrorg();
//        $calculofolha = new \Folha\Entities\MigCalculofolha();
//        $result = $calculofolha->getObjectByWhere('NRCALCULOFOLHA = ? AND NRORG = ?', array($nrcalculofolha, $nrorg));
//
//        if (is_object($result)) {
//            throw new \Exception(null);
//        } else {
//            $this->nrcalculofolha = $nrcalculofolha;
//        }

        $nrcalculofolha = \Importacao\Logic\Validacoes::verificaChaveDuplicada('FPA_CALCULOFOLHA', 'NRCALCULOFOLHA', ProjetoImportacao::getNrorg(), $nrcalculofolha);
        $this->nrcalculofolha = $nrcalculofolha;

    }


    /**
     * @param $nrtpmodalidcal
     * @return \Folha\Entities\MigCalculofolha
     */
    public function setNrtpmodalidcal ($nrtpmodalidcal) {
        if (empty($nrtpmodalidcal)) {
            $nrtpmodalidcal = self::DEFAULT_NRTPMODALIDCALC;
        }
        $this->nrtpmodalidcal = $nrtpmodalidcal;
    }

    /**
     * @param $dtocorrencia
     * @throws \Exception
     * @return \Folha\Entities\MigCalculofolha
     */
    public function setDtocorrencia ($dtocorrencia) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtocorrencia)) {
            throw new \Exception("Campo Obrigatório - Data de Ocorrência: Data '$dtocorrencia' com formato inválido ou em branco.");
        }

        if (!($dtocorrencia instanceof \DateTime)) {
            $dtocorrencia = DateUtil::getDataDeString($dtocorrencia);
        }

        $this->dtocorrencia = $dtocorrencia;
    }

    /**
     * @param $dtultatu
     * @throws \Exception
     * @return \Folha\Entities\MigCalculofolha
     */
    public function setDtultatu ($dtultatu) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido ou em branco.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

    /**
     * @param $dtinclusao
     * @throws \Exception
     * @return \Folha\Entities\MigCalculofolha
     */
    public function setDtinclusao ($dtinclusao) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data '$dtinclusao' com formato inválido ou em branco.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

}