CREATE OR REPLACE TRIGGER LOG_GER_SEGMERCABENS
AFTER UPDATE OR INSERT OR DELETE
ON SEGMERCABENS FOR EACH ROW
DECLARE
  V_TIPO         VARCHAR2(1);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
BEGIN
   /*IDTIPOOPER - '1' - Incluso, 
                  '2' - Alterao, 
                  '3' - Excluso*/

   V_TIPO       := '0';
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.CDSEGMENTO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdSegmento=' || :OLD.CDSEGMENTO;
      END IF;

      IF :OLD.DSSEGMENTO IS NOT NULL THEN
         V_DESC := V_DESC || ' DsSegmento=' || :OLD.DSSEGMENTO;
      END IF;

      V_TIPO   := '3';
      V_ITPESQ := :OLD.CDSEGMENTO;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDSEGMENTO,'!') <> NVL(:NEW.CDSEGMENTO,'!'))  OR
            (NVL(:OLD.DSSEGMENTO,'!') <> NVL(:NEW.DSSEGMENTO,'!'))  THEN

            IF NVL(:NEW.CDSEGMENTO, '!') <> NVL(:OLD.CDSEGMENTO, '!') THEN
               V_DESC := V_DESC||' CdSegmento='  || :NEW.CDSEGMENTO;
            END IF;

            IF NVL(:NEW.DSSEGMENTO, '!') <> NVL(:OLD.DSSEGMENTO, '!') THEN
               V_DESC := V_DESC||' DsSegmento='  || :NEW.DSSEGMENTO;
            END IF;

            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDSEGMENTO;
         END IF;
      ELSE
         IF NVL(:NEW.CDSEGMENTO, '!') <> NVL(:OLD.CDSEGMENTO, '!') THEN
            V_DESC := V_DESC||' CdSegmento='  || :NEW.CDSEGMENTO;
         END IF;

         IF NVL(:NEW.DSSEGMENTO, '!') <> NVL(:OLD.DSSEGMENTO, '!') THEN
            V_DESC := V_DESC||' DsSegmento='  || :NEW.DSSEGMENTO;
         END IF;

         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDSEGMENTO;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 600);

   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         INSERT INTO LOGOPERA
            (NMTABELA,
             DTOPERACAO,
             NMRESPOPER,
             IDTIPOOPER,
             DSOPERACAO,
             CDPESQITEM,
             DSRDMUSUOPER,
             DSENDUSUOPER,
             DSNMUSUOPER,
             DSMETUSUOPER,
             CDORESPOPER)
         VALUES
            ('SEGMERCABENS',
             SYSDATE,
             NVL(V_NMOPERADOR,' '),
             V_TIPO,
             V_DESC,
             V_ITPESQ,
             V_DSSERVERRDM,
             V_DSREMOTEADDR,
             V_DSREMOTEHOST,
             V_DSSERVMETHOD,
             V_DSREMOTEOPER);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_SEGMERCABENS','6.10.xxx'); END;
/
